#pragma once
#include <rewindow/types/window.h>
#include <rewindow/logger/logger.h>

namespace Engine {
    class DemoGameWindow;
}
class Engine::DemoGameWindow : public ReWindow::RWindow {
public:
    void InitGL();
    void Display();
public:
    void OnRefresh(float elapsed) override;
public:
    DemoGameWindow(const std::string& title, int width, int height) : ReWindow::RWindow(title, width, height)
    {
        ReWindow::Logger::Error.EnableConsole(false);
        ReWindow::Logger::Warning.EnableConsole(false);
        ReWindow::Logger::Debug.EnableConsole(false);
        SetRenderer(RenderingAPI::OPENGL);
        Open();
        InitGL();
        SetResizable(false);
        SetVsyncEnabled(false);
    }

};