#pragma once
#include <J3ML/Geometry/AABB2D.hpp>

namespace Engine {
    class BoxCollider;
}

class Engine::BoxCollider {
private:
    bool enabled = false;
public:
    [[nodiscard]] virtual AABB2D GetBounds() const = 0;
    [[nodiscard]] bool BoxCollides(BoxCollider* rhs) const;
    [[nodiscard]] bool BoxCollides(const Vector2& rhs) const;
public:
    void EnableBoxCollision() { enabled = true; }
    void DisableBoxCollision() { enabled = false; }
public:
    explicit BoxCollider(bool enabled = true) : enabled(enabled) {}
};