#pragma once

namespace Engine {
    class Renderable;
}

class Engine::Renderable {
private:
    unsigned int layer = 0;
    bool should_render = true;
public:
    [[nodiscard]] unsigned int GetLayer() const { return layer; }
    [[nodiscard]] virtual bool ShouldRender() const { return should_render; };
public:
    void SetLayer(unsigned int new_layer) { layer = new_layer; }
    virtual void ShouldRender(bool state) { should_render = state; }
    // *must* be overridden.
    virtual void Render() = 0;
public:
    // The default layer is 1 because zero would almost always be the HUD / score / some kind of overlay.
    explicit Renderable(unsigned int layer = 1, bool should_render = true) : should_render(should_render), layer(layer) {}
    virtual ~Renderable() = default;
};