#include <Engine/Globals.h>
#include <Game/scene/Loading.h>
#include <Game/scene/ControllableBox.h>

using namespace JGL;

void CreateScenes() {
    auto ld = new LoadingScreen("LoadingScreen");
    Globals::SceneList.push_back(ld);

    auto cb = new ControllableBox("Scene0");
    Globals::SceneList.push_back(cb);
};

int main() {
    Globals::Window = new Engine::DemoGameWindow("Demo Game", 1024, 896);

    CreateScenes();
    Globals::ChangeScene("LoadingScreen");

    while (Globals::Window->IsAlive())
        Globals::Window->ManagedRefresh();
}
