#include <Engine/types/ConcurrentWorker.h>
#include <Engine/Logger.h>

using namespace Engine;
ConcurrentWorker::~ConcurrentWorker() {
    if (!work_complete) {
        std::stringstream thread_id; thread_id << worker_thread.get_id();
        Logger::Fatal("ConcurrentWorker was destroyed for thread " + thread_id.str() + " but the work wasn't finished?");
    }
}

bool ConcurrentWorker::Done() {
    return work_complete;
}
