#include <Engine/types/InstancedTexture.h>
#include <Engine/types/entity/InstancedSprite.h>

using namespace Engine;
void InstancedTexture::AddUser(const InstancedSprite* user) {
    // Prevent double references.
    if (!InUseBy(user))
        users.push_back(user);
}

void InstancedTexture::RemoveUser(const InstancedSprite* user) {
    auto it = std::find(users.begin(), users.end(), user);
    if (it != users.end())
        users.erase(it);
}

bool InstancedTexture::InUseBy(const InstancedSprite* rhs) {
    if (users.empty())
        return false;

    if (typeid(*users[0]) == typeid(*rhs))
        return true;

    return false;
}

InstancedTexture::~InstancedTexture() {
    delete texture;
    for (const auto* is: users)
        delete is;
}
